#!/usr/bin/env python

# Inspire by Conbagui tutorial found here: https://web.archive.org/web/20150325204131/http://gimpchat.com/viewtopic.php?f=23&t=9466

# It Creates a plastic glassy like with a color center text
# author: Pocholo
# date: 8/17/2020

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugins folder



# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.



from gimpfu import *
import os, sys,time 
import gettext
gettext.install("gimp20", gimp.locale_directory, unicode=True)

def pm_plexiglass_bevel_text_logo(customtext, font, innerColor, glowColor):
	
    #Create a new image
    img = pdb.gimp_image_new(1, 1, RGB)

    #Initiates the temporary state
    pdb.gimp_context_push()
    pdb.gimp_context_set_defaults()
 
    #Create the text 	
    size = 450
    img = pdb.gimp_image_new(1, 1, RGB)
    pdb.gimp_context_set_foreground("Black")
    textLayer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 150,
                                   True, size, PIXELS, font)
    pdb.gimp_text_layer_set_justification(textLayer, 2)
    pdb.gimp_text_layer_set_letter_spacing(textLayer, 20)
    pdb.gimp_text_layer_set_line_spacing(textLayer, 0)
    img.resize(textLayer.width, textLayer.height, 0, 0)
    pdb.gimp_item_set_name(textLayer, "Text")
    pdb.gimp_layer_resize_to_image_size(textLayer)
    textLayer = pdb.gimp_image_get_layer_by_name(img, "Text")
    x = textLayer.offsets[0]
    y = textLayer.offsets[1]
    x = (img.width - textLayer.width) / 2
    y = (img.height - textLayer.height) / 2
    textLayer.set_offsets(x, y)
    pdb.gimp_layer_resize_to_image_size(textLayer)
        
    #Rename the text layer and move up
    pdb.gimp_item_set_name(textLayer, "Text")
        
    #Variables
    width = img.width
    height = img.height
    #Create background
    backLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, backLayer, 1)
    pdb.gimp_context_set_background('#052726')
    pdb.gimp_edit_fill(backLayer, FILL_BACKGROUND)

    gimp.Display(img)

    #Create the inner color layer
    innerlayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Inner color", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, innerlayer, 0)
    pdb.gimp_layer_add_alpha(innerlayer)
    pdb.gimp_drawable_fill(innerlayer, FILL_TRANSPARENT)
        
    #Create a selection on the text and shrink the selection
    pdb.gimp_image_select_item(img, 2, textLayer)
    pdb.plug_in_antialias(img, textLayer)
    pdb.gimp_selection_shrink(img, 10)	
    pdb.gimp_context_set_foreground(innerColor)
    pdb.gimp_edit_fill(innerlayer, FILL_FOREGROUND)
    pdb.plug_in_gauss(img, innerlayer, 3, 3, 1)

    #Outer Glow layer
    pdb.gimp_image_select_item(img, 2, textLayer)
    glowLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Text glow", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, glowLayer, 2)
    pdb.gimp_layer_add_alpha(glowLayer)
    pdb.gimp_drawable_fill(glowLayer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground(glowColor)
    pdb.gimp_edit_fill(glowLayer, FILL_FOREGROUND)
    pdb.gimp_selection_none(img)
    pdb.plug_in_gauss(img, glowLayer, 21, 21, 1)

    #Bevel and Emboss	
    pdb.python_layerfx_bevel_emboss(img, textLayer, 
                                                 0,   #style inner bevel
                                                65,   #depth 
                                                 0,   #direction 
                                                46,   #size 
                                                 5,   #soften
                                               120,   #angle 
                                                30,   #altitude 
                                                 2,   #gloss_contour 
                                   (207, 255, 252),   #highlight_color 
                                                 4,   #highlight_mode-screen
                                                75,   #highlight_opacity
                                       (0, 85, 69),   #shadow_color 
                                                 3,   #shadow_mode-multiply
                                                75,   #shadow_opacity 
                                                 1,   #surface_contour 
                                             FALSE,   #use_texture 
                                       "Dried mud",   #pattern 
                                               100,   #scale 
                                               100,   #tex_depth 
                                              TRUE,   #invert 
                                             FALSE)   #merge		

    #Create the colors layer using gradient
    colorsLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB_IMAGE, "Colors", 100, LAYER_MODE_GRAIN_EXTRACT)
    pdb.gimp_image_add_layer(img, colorsLayer, 3)
    pdb.gimp_layer_add_alpha(colorsLayer)
    pdb.gimp_drawable_fill(colorsLayer, FILL_TRANSPARENT)
    pdb.gimp_context_set_gradient("Full saturation spectrum CCW")
    pdb.gimp_drawable_edit_gradient_fill(colorsLayer, 0, 0, TRUE, 3, 0.20, TRUE, 0, 0, 0, img.height)

    #Color Overlay			 
    pdb.python_layerfx_color_overlay(img, textLayer, 
                                    (255, 255, 255),   #color
                                                100,   #opacity
                                                  0,   #mode-normal  
                                              FALSE)   #merge


    #Resets the previous user defaults
    pdb.gimp_context_pop()
	
register(
    "pm_plexiglass_bevel_text_logo",
    "Creates a lurid text logo",
    "Creates a lurid text logo",
    "Pocholo",
    "Pocholo",
    "2020",
    "Plexiglass bevel text logo",
    "",
    [
    (PF_TEXT, "customtext", "Text string", "PLEXI\nGLASS"),
    (PF_FONT, "font", "Font face", "Arial Bold"),
    (PF_COLOR, "innerColor", "Inner color", (0, 255, 255)),
    (PF_COLOR, "glowColor", "Glow color", (0, 255, 255)),
    ],
    [],
    pm_plexiglass_bevel_text_logo, menu="<Image>/Pocholo-scripts/Plexiglass bevel text logo",
    domain=("gimp20", gimp.locale_directory))
main()				